// Scene.cpp: implementation of the Scene class.
//
//////////////////////////////////////////////////////////////////////

#include "Scene.h"

// Create the shader declaration.
DWORD dwDecl[] =
{
    D3DVSD_STREAM(0),
    D3DVSD_REG(0, D3DVSDT_FLOAT3),      // the position data
    D3DVSD_REG(1, D3DVSDT_FLOAT3),		// normal
	D3DVSD_REG(2, D3DVSDT_FLOAT2),		// texture coord 0
	D3DVSD_REG(3, D3DVSDT_FLOAT3),		// Tangent
	D3DVSD_REG(4, D3DVSDT_FLOAT3),		// Binormal
    D3DVSD_END()
};

int Scene::sirka,Scene::vyska;
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Scene::Scene()
{
	pvb_help_rectange = NULL;
	hVertexShader_for_ps_10 = NULL;
	hVertexShader_for_ps_14 = NULL;
	hVertexShader_Cube_Mapping = NULL;
	hPixelShader10 = NULL;
	hPixelShader14 = NULL;
	font0 = NULL;
	c = NULL;

	fps = 200;							// v pripade ze nieco zavisy od fps
	timeframe = 1.f/fps;

	if( HIBYTE(LOWORD(caps.PixelShaderVersion))==0 )
	{
		{ 	MessageBox( hWnd, "Pixel Shader Version must by >= 1.0", "ERROR", MB_OK); error=1;	}
	}
	if(error)return;

	if( HIBYTE(LOWORD(caps.PixelShaderVersion))==0 ||
	   (HIBYTE(LOWORD(caps.PixelShaderVersion))==1 && LOBYTE(LOWORD(caps.PixelShaderVersion))<4) )
		ps14 = 0;
	else
		ps14 = 1;
	if(ps14)ps14_is_set = 1;
	else ps14_is_set = 0;

	InitDX();
	ShowCursor(0);
	if(!CreateVertexBufferForHelpRectange(10,screen_y_font-45,screen_x_font-10,230,0.5f)){	error = 1;	return;}

	font0 = new Font_bitmap("data/font.bmp");
	if(error)return;

	FILE* fi;
	fi = fopen("data/Earthbump.JPG","rb");
	if(fi==NULL)
	{
		english ? MessageBox(hWnd,"Copy file Earthbump.JPG from DX program 10 to folder data","Missing file: data/Earthbump.JPG",MB_OK):
		          MessageBox(hWnd,"Skopiruj subor Earthbump.JPG z DX programu 10 do adresara data","Chyba subor: data/Earthbump.JPG",MB_OK);
	}
	else fclose(fi);
	
	pd->Clear( 0, NULL, D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER, D3DCOLOR_XRGB(0,0,0), 1.0f, 0 );
    pd->BeginScene();
	font0->Begin();
	font0->Print_xy_scale(60,450,"Bumped Cubic Environment Mapping",0,2,3);
	font0->Print_xy_scale(160,380,english? "Loading models and creating normal maps":"Nacitavam modely a vytvaram normal mapy",0,1.2f,1.2f);
	font0->Print_xy_scale(300,320,"Marek Mizanin",0,1.5f,1.5f);
	font0->Print_xy_scale(260,280,"www.mizanin.szm.sk",0,1.5f,1.5f);
	font0->Print_xy_scale(english ? 340:300,240,english ? "Key H - help" : "Klavesa H - Help",0,1.0f,1.0f);
	font0->End();
	pd->EndScene();
	pd->Present( NULL, NULL, NULL, NULL );

	c = new camera;

	if(!skybox[0].Init(15.f)){	error = 1;	return;}
	if(!skybox[1].Init(15.f)){	error = 1;	return;}
	if(!skybox[0].LoadTextureSkyBox("data/skybox/","jpg")){	error = 1;	return;}
	if(!skybox[1].LoadTextureSkyBox("data/mars/","jpg")){	error = 1;	return;}

	C3ds* p3ds;
	p3ds = new C3ds("data/sphere.3ds", 2, 0, 0, 1); 
	obj.push_back(p3ds);if(error)return;	p3ds->Rescale(3.f);
	
	p3ds = new C3ds("data/quad_dot3/quad.3ds", 2, 0, 0, 1); 
	obj.push_back(p3ds);if(error)return;	p3ds->Rescale(3.f);

	p3ds = new C3ds("data/teapot_textur.3DS", 2, 0, 0, 1); 
	obj.push_back(p3ds);if(error)return;	p3ds->Rescale(3.f);	

	texture* pt;
	Image im;
	for(int i=0; i<8; i++)
	{
		switch(i)
		{
		case 0:	
			if(!im.LoadNoMessage("data/Earthbump.JPG"))
			{
			//	english ? MessageBox(hWnd,"Copy file Earthbump.JPG from DX program 10 to folder data","File is missing",MB_OK):
			//	          MessageBox(hWnd,"Skopiruj subor Earthbump.JPG z DX programu 10 do adresara data","Chybajuci subor",MB_OK);
				continue;
			}
			else
				im.resizeToHalfX();
			break;
		case 1:	if(!im.Load("data/bump_maps/nvlogo_bump_1.jpg"))error=1; break;
		case 2:	if(!im.Load("data/bump_maps/bump_map1.jpg"))error=1; break;
		case 3:	if(!im.Load("data/bump_maps/bump_map_torus.jpg"))error=1; break;
		case 4:	if(!im.Load("data/bump_maps/opengl.jpg"))error=1; break;
		case 5:	if(!im.Load("data/bump_maps/bump_map_noisy.jpg"))error=1; break;
		case 6: if(!im.Load("data/bump_maps/Tur3bump.jpg"))error=1; break;
		case 7: if(!im.Load("data/bump_maps/mm.jpg"))error=1; break;
		}
		
		im.Filter(0,0,0.2f);
	//	if(i==6)im.SaveBMP("bmp.bmp");
		pt = new texture;
		if(!pt->load(im))error=1;
		ptex.push_back(pt);
		if(error)return;
	}

	if(error)return;
	
	for( i=0; i<obj.size(); i++)
		if(!obj[i]->CreateDXObjects()){	error = 1;	return;}

	if(!LoadVertexShader( "Shaders/014_Bumpy_Environment_Mapping/vertex_shader_for_ps_10.txt", dwDecl, &hVertexShader_for_ps_10)){	error = 1;	return;}
	if(!LoadVertexShader( "Shaders/014_Bumpy_Environment_Mapping/vertex_shader_Cube_Mapping.txt", dwDecl, &hVertexShader_Cube_Mapping)){	error = 1;	return;}
	if(!LoadPixelShader( "Shaders/014_Bumpy_Environment_Mapping/pixel_shader_10.txt", &hPixelShader10)){	error = 1;	return;}
	if(ps14)
	{
		if(!LoadVertexShader( "Shaders/014_Bumpy_Environment_Mapping/vertex_shader_for_ps_14.txt", dwDecl, &hVertexShader_for_ps_14)){	error = 1;	return;}
		if(!LoadPixelShader( "Shaders/014_Bumpy_Environment_Mapping/pixel_shader_14.txt", &hPixelShader14)){	error = 1;	return;}
	}
	if(!cube[0].load("data/skybox/", "jpg"))error = 1;
	if(!cube[1].load("data/mars/", "jpg"))error = 1;
}

Scene::~Scene()
{
	if(hPixelShader10!=NULL)pd->DeletePixelShader( hPixelShader10);
	if(hPixelShader14!=NULL)pd->DeletePixelShader( hPixelShader14);
	if(hVertexShader_for_ps_10!=NULL)pd->DeleteVertexShader( hVertexShader_for_ps_10);
	if(hVertexShader_for_ps_14!=NULL)pd->DeleteVertexShader( hVertexShader_for_ps_14);
	if(hVertexShader_Cube_Mapping!=NULL)pd->DeleteVertexShader( hVertexShader_Cube_Mapping);
	for(int i=0; i<obj.size(); i++)
		if(obj[i]!=NULL) delete obj[i];
	for( i=0; i<ptex.size(); i++)
		if(ptex[i]!=NULL) delete ptex[i];
	if(font0!=NULL) delete font0;
	if(c!=NULL) delete c;
	if(pvb_help_rectange!=NULL) pvb_help_rectange->Release();
	ShowCursor(1);
}

void Scene::DrawDXScene()
{
	mat4 m;
    if( NULL == pd )return;
	if(keys['L'] && keys[VK_CONTROL]){ english = !english; keys['L']=0; }

    // Clear the backbuffer to a black color
	pd->Clear( 0, NULL, D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER, D3DCOLOR_XRGB(0,0,0), 1.0f, 0 );

    // Begin the scene
    pd->BeginScene();

	c->MoveWorld( fps, ROTATE_WALK|ROTATE_ABOUT_POINT);
	c->SetTransform();

	if(keys['P'])pd->SetRenderState( D3DRS_FILLMODE, D3DFILL_WIREFRAME);
	else pd->SetRenderState( D3DRS_FILLMODE, D3DFILL_SOLID);

	static int model=0;
	
	if(keys['1'])model=0;
	else if(keys['2'] && obj.size()>1)model=1;
	else if(keys['3'] && obj.size()>2)model=2;
	else if(keys['4'] && obj.size()>3)model=3;

	static int texture_index=0;
	if(keys[VK_SPACE])
	{
		texture_index++;
		if(texture_index>=ptex.size())texture_index=0;
		keys[VK_SPACE]=0;
	}
	if(keys[VK_BACK])
	{
		texture_index--;
		if(texture_index<0)texture_index=ptex.size()-1;
		keys[VK_BACK]=0;
	}

	static int cube_mat_index=0;
	if(keys['X'])
	{
		cube_mat_index=!cube_mat_index;
		keys['X']=0;
	}

	static int rot_cube_map=1;
	if(keys['Z']){	rot_cube_map = !rot_cube_map; keys['Z']=0;}
	
//	if(keys['T'])pd->SetRenderState(D3DRS_CULLMODE, D3DCULL_CW );
//	else pd->SetRenderState(D3DRS_CULLMODE, D3DCULL_NONE );

	mat4 proj,mod;

	pd->GetTransform( D3DTS_PROJECTION, (D3DMATRIX*) proj.m );
	pd->GetTransform( D3DTS_WORLD, (D3DMATRIX*) mod.m );

	static mat4 C;		// transformacia z SS camery do SS cube mapy
	if(rot_cube_map)	// rot_cube_map
	{
		mat4 ms;
		ms.Scale(1,1,-1);
		C = ms*mod;
		C.m14 = 0;
		C.m24 = 0;
		C.m34 = 0;
		C = ~C;			// C = ~M, M upper-left 3x3 of the the modelview matrix
	}

	m = proj*mod;

	pd->SetVertexShaderConstant(  0, (~m).m, 4 );		// c0-c3 contains composite transform matrix
	if(keys['C'])	// cube mapping only
	{
		vec4 eye;		// camera position
		mat4 cubemap_rot,ms;
		eye = (!mod)*vec(0,0,0);	// bod (0,0,0) v suradniciach camery = eye v suradniciach objektu
		ms.Scale(1,1,-1);
		cubemap_rot = C*ms*mod;	// transformacia z SS objektu do SS cube mapy
		pd->SetVertexShaderConstant(  10, (~cubemap_rot).m, 4 );
		vec4 c7(-2,-2,-2,-2);			// for cube mapping
		pd->SetVertexShaderConstant(  6, eye.v, 1 );	// c6 eye in object space
		pd->SetVertexShaderConstant(  7, c7.v, 1 );		// c7   -2,-2,-2,-2
	}

/*
True Reflective Bump Mapping
Bumped Cubic Environment Mapping
Mapovanie okolia na hrbolaty reflexny povrch

Aby sme mohli robit pravy bump mapping musime vypocitat reflexny vektor R
po pixeli a ten pouzit na nacitanie farby z cube mapy.
Reflesny luc sa vypocitava:

R = 2*N(N.E) - E
ak E je normalizovany vektor od bodu k oku
N je normalizovany normalovy vektor

Ak N nie je normalizovany mozme pouzit taketo priblizne vzorce:
    2*N(N.E)
R = -------- - E    , alebo  R = 2*N(N.E) - E(N.N)
      (N.N)
Vektory E a N musia byt v rovnakej suradnicovej sustave !!!
Vysledny vektor R je tak isto v tejto suradnicovej sustave.

Kedze vektor R pouzijeme na citanie z cube mapy, vektor R musi 
byt v cube map suradicovom systeme. Z toho vypliva, ze aj
E a N musia byt v cube map suradnicovom systeme (dalej ako SS).

Kedze chceme robit per-pixel (po-pixeli) emvironment bump mapping 
musime po-pixeli specifikovat vektory N a E.

Vektor N je dany texturou a je v SS textury. Ale my potrebujeme aby bol v SS cube mapy !
Preto musime normalovy vektor (po-pixeli) transformovat maticou T 
velkosti 3x3 do SS cube mapy. N' = T*N

Vektor N by mohol byt zadany aj v SS objektu, ale aj tak by sme sa transformacii do cube map SS nevyhli.

Matica T je transformacia zo SS textury do SS cube mapy a sklada sa z tychto krokov:
1. zmensenie, zvacsenie hrbolatosti povrchu pomocou matice B ( tuto maticu je mozne vynechat )
2. transformacia zo SS textury do SS objektu, pomocou matice S
3. transformacia zo SS objektu do SS camery, pomocou matice M
4. transformacia zo SS camery do SS cube mapy, pomocou matice C
T = C.M.S.B

Matica S:
transformuje x suradnicu na texture (reprezentovanu red   zlozkov) na tangent-ovy vektor objektu.
transformuje y suradnicu na texture (reprezentovanu green zlozkov) na binormal-ovy vektor objektu.
transformuje z suradnicu na texture (reprezentovanu blue  zlozkov) na normal-ovy vektor objektu.
    ( Tan.x  Bin.x  Nor.x )
S = ( Tan.y  Bin.y  Nor.y )
    ( Tan.z  Bin.z  Nor.z )

Matica M:
je to 3x3 lava-horna submatica z inverznej a transponovanej modelovacej matice
(The upper-left 3x3 of the inverse transpose of the modelview matrix)
Ak je modelovacia matica iba rotacno - posuvna, tak M je 3x3 lava-horna submatica modelovacej matice

Matica C:
vyjadruje rotaciu cube mapy k SS camery. Plati:
ak nase okolie je pevne tak C = I (jednotkova matica)
ak nase okolie je pohyblive tak C = inverzna(M) = transponovana(M),                       -1   T
    kde M je 3x3 lava-horna submatica modelovacej matice, pre cisto rotacne matice plati M  = M
	v tomto pripade sa C.M = I a tak T = S

Matica B:
    ( b  0  0 )
B = ( 0  b  0 )  , b vyjadruje hrbolatost
    ( 0  0  1 )
Vektor E je normalizovany vektor od bodu k oku, a musi byt v SS cube mapy
E = eye - vertex
Najednodusie je vypocita E v SS camery, lebo tam plati eye = (0,0,0), potom
E = - vertex_v_SS_camery = - M * vertex_v_SS_objektu = (-M)*vertex
My potrebujeme E v SS cube mapy, preto musime E este transformovat maticou C
E = C*(-M)*vertex = (- (C*M))*vertex
E este treba normalizovat.
Tento vypocet nema vyznam prevadzat po pixeli, kedze vrcholy nemame zadavane po pixeli.
Vektor E mozeme linerane interpolovat.
Vektor E je mozne normalizovat a interpolovat pomocou cube mapy (iba ps 1.4, ale ja to nevyuzivam).

Predpoklady:
Kazdy vrchol objektu musi mat:
poziciu, texturovu koordinaciu, vektory Tangent, Binormal, Normal
u mna su (pozri dwDecl) namapovane na vertex shader takto:
poziciu (v0), texturovu koordinaciu(v2), Tangent(v3), Binormal(v4), Normal(v1)
Konstanty pre vertex shader:
c0 ..c3   - composite transform matrix
c20..c23  - cubemap_modelview
c24..c27  - negate_cubemap_modelview
Vertex shader pocita:
oPos	- transformovana pozicia vertexu
oT0.xy	- texturova koordinacia pre normalovu mapu
oT1.xyz
oT2.xyz - obsahuju maticu T = C.M.S.B = (c[20..23]).S.B
oT3.xyz
(oT1.w, oT2.w, oT3.w) - obsahuju E v SS cube mapy, E = (c[24..27).vertex
pre ps 1.0 E nemusi byt normalizovany
pre ps 1.4 E musi byt normalizovany a zadavam ho v oT4.xyz

Pixel shader 1.0:
textura 0 predstavuje normal mapu
riadky matice T su v t1,t2,t3
cube mapa je nastavene v t3
istrukcie texm3x3pad prevadzaju nasobenie riadku matice z texturov 0
instrukcia texm3x3vspec, prevadza posledne nasobenie riadku a zaroven
vypocita vektor R, podla vzorca:
    2*N(N.E)
R = -------- - E
      (N.N)
a na vystup zapise farbu nacitanu z cube mapy pomocou R

Pixel shader 1.4
nepouziva ziadne specialne instrukcie pre tento pripad
Vypocet je plne naprogramovany, R sa pocita podla vzorca:
R = 2*N(N.E) - E(N.N), vysledna farba sa nacita podla R z cube mapy
*/
	static vec4 bump_scale_x(1,0,0,0);
	static vec4 bump_scale_y(0,1,0,0);
	static vec4 bump_scale_z(0,0,1,0);
	static int bump_setting=3;

	if(keys['M'] && keys['N'])
	{
		bump_scale_x.x = 1.0f;
		bump_scale_y.y = 1.0f;
		bump_scale_z.z = 1.0f;
	}
	if(keys['M'])
	{
		switch(bump_setting)
		{
		case 0: bump_scale_x.x += 0.3f*timeframe; break;
		case 1: bump_scale_y.y += 0.3f*timeframe; break;
		case 2: bump_scale_z.z += 0.3f*timeframe; break;
		case 3: 
			bump_scale_x.x += 0.3f*timeframe; 
			bump_scale_y.y += 0.3f*timeframe; 
			break;
		}
	}
	else if(keys['N'])
	{
		switch(bump_setting)
		{
		case 0: bump_scale_x.x -= 0.3f*timeframe; break;
		case 1: bump_scale_y.y -= 0.3f*timeframe; break;
		case 2: bump_scale_z.z -= 0.3f*timeframe; break;
		case 3: 
			bump_scale_x.x -= 0.3f*timeframe; 
			bump_scale_y.y -= 0.3f*timeframe; 
			break;
		}
	}
	if(keys['B'])
	{
		bump_setting++;
		if(bump_setting>3)bump_setting=0;
		keys['B']=0;
	}

	mat4 ms,M;
	ms.Scale(1,1,-1);
	M = ms*mod;
	m = C*M;		// C - rotacia z SS camery do SS cube mapy

	pd->SetVertexShaderConstant( 20, (~m).m, 4 );	// cubemap_modelview matrix
	m = -m;
	pd->SetVertexShaderConstant( 24, (~m).m, 4 );	// negate_cubemap_modelview
	pd->SetVertexShaderConstant( 30, bump_scale_x.v, 1 );	// bump_scale_x
	pd->SetVertexShaderConstant( 31, bump_scale_y.v, 1 );	// bump_scale_y
	pd->SetVertexShaderConstant( 32, bump_scale_z.v, 1 );	// bump_scale_z
	
	if(ps14 && keys['V'])
	{
		ps14_is_set = !ps14_is_set;
		keys['V']=0;
	}
	if(keys['C'])	// cube mapping only
	{
		cube[cube_mat_index].SetTexture(0);
		pd->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTSS_COLORARG1 );
		pd->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
		obj[model]->Render(2,0,hVertexShader_Cube_Mapping);		// cube mapping
	}
	else
	{
		cube[cube_mat_index].SetTexture(3);
		ptex[texture_index]->SetTexture(0);

		if(ps14_is_set)
		{
			pd->SetPixelShader( hPixelShader14 );
			obj[model]->Render(2,0,hVertexShader_for_ps_14);
		}
		else
		{
			pd->SetPixelShader( hPixelShader10 );
			obj[model]->Render(2,0,hVertexShader_for_ps_10);
		}

		pd->SetPixelShader( NULL );
	}
//	sphere->Render_dot3(0);								// normal map
	
	{
		mat4 ms;
		ms.Scale(1,1,-1);
		m.Identity();
		m = ms*(!C);
		m.m14 = mod.m14;
		m.m24 = mod.m24;
		m.m34 = mod.m34;
		pd->SetTransform( D3DTS_WORLD, (D3DMATRIX*) m.m );
	}
	pd->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTSS_COLORARG1 );
	pd->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
	pd->SetRenderState( D3DRS_CULLMODE, D3DCULL_CW);
	skybox[cube_mat_index].Render();
	pd->SetRenderState( D3DRS_FILLMODE, D3DFILL_SOLID);
	
	font0->Begin();
	// vypis FPS
	timeframe = timer0.GetTime();
	fps = 1.0f / timeframe;
	timer0.Reset();
	fps_counter.GetAvgFps(timeframe,0.2f);
	gcvt( (double)fps_counter.avg_fps, 4, text);
	font0->Print( 0, 0, text, 0);
	
	if(keys[VK_F12])
	{
		font0->End();
		pd->EndScene();
		pd->Present( NULL, NULL, NULL, NULL );
		SaveScreen_BMP();
		return;
	}
	if(ps14_is_set)
		font0->Print( 0, 1, "ps 1.4", 0);

	font0->SetColor(1,0,0);
	switch(bump_setting)
	{
	case 0: font0->Print_float(0, 2, bump_scale_x.x, "x:"); break;
	case 1: font0->Print_float(0, 3, bump_scale_y.y, "y:"); break;
	case 2: font0->Print_float(0, 4, bump_scale_z.z, "z:"); break;
	case 3: 
		font0->Print_float(0, 2, bump_scale_x.x, "x:");
		font0->Print_float(0, 3, bump_scale_y.y, "y:");
		break;
	}
	font0->SetColor(1,1,1);
	switch(bump_setting)
	{
	case 0: 
		font0->Print_float(0, 3, bump_scale_y.y, "y:");
		font0->Print_float(0, 4, bump_scale_z.z, "z:");
		break;
	case 1: 
		font0->Print_float(0, 2, bump_scale_x.x, "x:");
		font0->Print_float(0, 4, bump_scale_z.z, "z:");
		break;
	case 2: 
		font0->Print_float(0, 2, bump_scale_x.x, "x:");
		font0->Print_float(0, 3, bump_scale_y.y, "y:");
		break;
	case 3: 
		font0->Print_float(0, 4, bump_scale_z.z, "z:");
		break;
	}
	if(keys['H'])				//vypise help
	{
		int i=3;

		// first draw rectange
		pd->SetRenderState( D3DRS_LIGHTING, 0 );
		m.Identity();
		pd->SetTransform( D3DTS_WORLD, (D3DMATRIX*) m.m);
		pd->SetTextureStageState( 0, D3DTSS_COLOROP, D3DTOP_SELECTARG1 );
		pd->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_DIFFUSE );

		pd->SetRenderState( D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
		pd->SetRenderState( D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA );
		
		pd->SetStreamSource( 0, pvb_help_rectange, 3*sizeof(float)+sizeof(DWORD));
		pd->SetVertexShader( D3DFVF_XYZ|D3DFVF_DIFFUSE );
		pd->DrawPrimitive( D3DPT_TRIANGLESTRIP, 0, 2 );

		pd->SetRenderState( D3DRS_SRCBLEND,  D3DBLEND_INVDESTCOLOR);
		pd->SetRenderState( D3DRS_DESTBLEND, D3DBLEND_SRCALPHA );
		
		pd->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_MODULATE );
		pd->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
		pd->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );
		pd->SetRenderState( D3DRS_LIGHTING, 1 );

		font0->Print(21,i++,"Program: Bumped Cubic Environment Mapping", 0);
		font0->SetColor(0.9f,0.9f,1.0f,1.f);

		if(english)
		{
			font0->Print(8,i++,"Programmer: Marek Mizanin - www.mizanin.szm.sk",0);
			font0->SetColor();
			font0->Print(10,i++,"Controls:", 1);
			font0->Print(10,i++,"1,2,3 - change model", 1);
			font0->Print(10,i++,"space, back space - change normal map", 1);
			font0->Print(10,i++,"X - change cube map", 1);
			font0->Print(10,i++,"C - switch on only cube mapping",1);
			if(ps14)font0->Print(10,i++,"V - change version pixel shader between 1.0 and 1.4", 1);
			font0->Print(10,i++,"Z - on/off rotation of cube map",1);
			font0->Print(10,i++,"P - wire frame",1);
			font0->Print(10,i++,"B - switch setting parameter",1);
			font0->Print(10,i++,"M - increase, N - decrease setting parameter", 1);

			i++;
			font0->Print(10,i++,"F12 - take screenshot",1);
			font0->Print(10,i++,"H - help", 1);
			font0->Print(10,i++,"mouse, button on mouse - moving",1);
			font0->Print(10,i++,"arrow,Page Up,Page Down,A,D,W,S,home,end,delete,insert -moving",1);
			font0->Print(10,i++,"shift - slow moving",1);
			font0->Print(10,i++,"R - reset camera",1);
			font0->Print(10,i++,"F4 - toggle fullscreen", 1);
		}
		else
		{
			font0->Print(8,i++,"Naprogramoval: Marek Mizanin - www.mizanin.szm.sk",0);
			font0->SetColor();
			font0->Print(10,i++,"Pouzivane klavesy:", 1);
			font0->Print(10,i++,"1,2,3 - meni model", 1);
			font0->Print(10,i++,"medzernik, back space - meni normalovu mapu", 1);
			font0->Print(10,i++,"X - meny cube mapu", 1);
			font0->Print(10,i++,"C - zapne iba cube mapping",1);
			if(ps14)font0->Print(10,i++,"V - meni verziu pixel shader medzi 1.0 a 1.4", 1);
			font0->Print(10,i++,"Z - zapina/vypina rotaciu cube mapy",1);
			font0->Print(10,i++,"P - zapne ciarovy rezim", 1);
			font0->Print(10,i++,"B - meni nastavovany parameter pre hrbolatost povrchu",1);
			font0->Print(10,i++,"M,N - nastavuje parameter", 1);

			i++;
			font0->Print(10,i++,"F12 - urobi screenshot",1);
			font0->Print(10,i++,"H - help", 1);
			font0->Print(10,i++,"mys, tlacitka na mysi - pohyb", 1);
			font0->Print(10,i++,"sipky,Page Up,Page Down,A,D,W,S,home,end,delete,insert - pohyb", 1);
			font0->Print(10,i++,"shift - pomaly alebo rychli pohyb", 1);
			font0->Print(10,i++,"R - reset kamery", 1);
			font0->Print(10,i++,"F4 - prepina do/z fullscreen", 1);
		}
	}
	font0->End();
	
	// End the scene
	pd->EndScene();

	// Present the backbuffer contents to the display
	pd->Present( NULL, NULL, NULL, NULL );
}

void Scene::ReSizeDXScene(int width, int height)
{
	sirka = width;
	vyska = height;

	D3DXMATRIX matProj;
	D3DXMatrixPerspectiveFovLH( &matProj, FIELD_OF_VIEW*PI180, (float)sirka/(float)vyska, Z_NEAR_VIEW_PLANE, Z_FAR_VIEW_PLANE );
//	D3DXMatrixOrthoOffCenterLH( &matProj, 0, 800, 0, 600, -1, 1 );
	pd->SetTransform( D3DTS_PROJECTION, &matProj );
}

void Scene::InitDX()
{
	if(!fullscreen)
	{
		RECT		WindowRect;					// miesto pre velkost okna
		WindowRect.left=(long)0;
		WindowRect.top=(long)0;
		GetClientRect(hWnd,&WindowRect);				//zistenie rozmerov uzivatelskej casti okna
		ReSizeDXScene(WindowRect.right,WindowRect.bottom);	//nastavenie perspektivy
	}
	else ReSizeDXScene(screen_x, screen_y);	//definovana v tomto subore

	pd->SetRenderState(D3DRS_CULLMODE, D3DCULL_NONE );
	
	// Enable z-buffering.
	pd->SetRenderState(D3DRS_ZENABLE, D3DZB_TRUE);
	pd->SetRenderState(D3DRS_ZFUNC, D3DCMP_LESS);

	mat4 m;	
	pd->SetTransform( D3DTS_VIEW, (struct _D3DMATRIX *)(void*)&m );
	pd->SetTransform( D3DTS_WORLD, (struct _D3DMATRIX *)(void*)&m );

	D3DMATERIAL8 mtrl;
	ZeroMemory( &mtrl, sizeof(D3DMATERIAL8) );
	mtrl.Diffuse.r = mtrl.Ambient.r = 1.0f;
	mtrl.Diffuse.g = mtrl.Ambient.g = 1.0f;
	mtrl.Diffuse.b = mtrl.Ambient.b = 1.0f;
	mtrl.Diffuse.a = mtrl.Ambient.a = 1.0f;
	pd->SetMaterial( &mtrl );

	ZeroMemory( &light0, sizeof(D3DLIGHT8) );
//	light0.Type = D3DLIGHT_DIRECTIONAL;
	light0.Type = D3DLIGHT_POINT;
//	light0.Diffuse.r = 1.0f;	light0.Diffuse.g = 1.0f;	light0.Diffuse.b = 1.0f;
	light0.Diffuse.r = 0.8f;	light0.Diffuse.g = 0.8f;	light0.Diffuse.b = 0.8f;
	light0.Diffuse.a = 1.0f;

	light0.Ambient.r = 0.0f;
	light0.Ambient.g = 0.0f;
	light0.Ambient.b = 0.0f;
	light0.Ambient.a = 1.0f;

	light0.Direction.x = 0;	light0.Direction.y = 0;	light0.Direction.z = 1;
	
	light0.Position.x = 0;
	light0.Position.y = 0;
	light0.Position.z = -10;
	light0.Attenuation0 = 1.f;

	light0.Range = 1000;

	pd->SetLight( 0, &light0 );
//	pd->LightEnable( 0, TRUE);
	pd->SetRenderState( D3DRS_AMBIENT, D3DCOLOR_COLORVALUE(0.2f,0.2f,0.2f,1) );
//	pd->SetRenderState( D3DRS_AMBIENT, D3DCOLOR_COLORVALUE(0.0f,0.0f,0.0f,1) );

	pd->SetTextureStageState( 0, D3DTSS_MINFILTER,D3DTEXF_LINEAR);
	pd->SetTextureStageState( 0, D3DTSS_MAGFILTER,D3DTEXF_LINEAR);
	pd->SetTextureStageState( 0, D3DTSS_MIPFILTER,D3DTEXF_LINEAR);

	for(int i=1; i<caps.MaxSimultaneousTextures; i++)
	{
		pd->SetTextureStageState( i, D3DTSS_MINFILTER,D3DTEXF_LINEAR);
		pd->SetTextureStageState( i, D3DTSS_MAGFILTER,D3DTEXF_LINEAR);
		pd->SetTextureStageState( i, D3DTSS_MIPFILTER,D3DTEXF_LINEAR);
	}
//	pd->SetTextureStageState(0, D3DTSS_MAXANISOTROPY,16);
//	pd->SetTextureStageState(1, D3DTSS_MAXANISOTROPY,16);
//	pd->SetTextureStageState(2, D3DTSS_MAXANISOTROPY,16);
	pd->SetRenderState( D3DRS_LIGHTING, 0 );
}

void Scene::SaveScreen_BMP()
{
	int scr_size_x; int scr_size_y;
	IDirect3DSurface8 *sur;
	D3DDISPLAYMODE Mode;
	
	pd->GetDisplayMode( &Mode);
	Mode.Format = D3DFMT_A8R8G8B8;
	if(pd->CreateImageSurface(Mode.Width, Mode.Height, Mode.Format, &sur)!=D3D_OK )return;
	
	D3DSURFACE_DESC surd;
	if(pd->GetFrontBuffer( sur)!=D3D_OK){sur->Release(); return;}
	sur->GetDesc( &surd);

	D3DLOCKED_RECT LockedRect;
	if(sur->LockRect( &LockedRect, NULL, D3DLOCK_READONLY)!=D3D_OK)
	{
		sur->UnlockRect();
		sur->Release();
		return;
	}

	scr_size_x = surd.Width;
	scr_size_y = surd.Height;

	BITMAPFILEHEADER fileheader;
	BITMAPINFOHEADER infoheader;

	FILE *sub;
	int line_size = 3*scr_size_x;
	if(line_size%4)line_size += 4 - line_size%4;

	unsigned char* buf = new unsigned char[3*line_size*scr_size_y];
	char file[30];

	if(buf==NULL )
	{
		sur->UnlockRect();
		sur->Release();
		return;
	}

	int Pitch = LockedRect.Pitch;
	unsigned char* p = (unsigned char*) LockedRect.pBits;
	for(unsigned int y=0; y<surd.Height; y++)
	{
		for(unsigned int x=0; x<surd.Width; x++)
		{
			buf[line_size*y+3*x+0] = p[Pitch*(surd.Height-y-1)+4*x+0];
			buf[line_size*y+3*x+1] = p[Pitch*(surd.Height-y-1)+4*x+1];
			buf[line_size*y+3*x+2] = p[Pitch*(surd.Height-y-1)+4*x+2];
		}
	}
	sur->UnlockRect();
	sur->Release();

	for(int c=0;c<999;c++)
	{
		char pom[20];
		strcpy(file,"screen");
		if(c<100)strcat(file,"0");
		if(c<10)strcat(file,"0");
		strcat(file,itoa(c,pom,10));
		strcat(file,".bmp");
		sub = fopen(file,"r");
		if(sub==NULL)break;
		if(sub!=NULL)fclose(sub);
	}
	
	fileheader.bfType = 0x4D42; // Magic identifier   - "BM"	| identifikacia BMP suboru musi byt "BM"
	fileheader.bfSize = 3*scr_size_x*scr_size_y+sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER);	// File size in bytes			| velkos suboru v byte
	fileheader.bfReserved1 = 0;
	fileheader.bfReserved2 = 0;
	fileheader.bfOffBits = sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER);	// Offset to image data, bytes	| posun na zaciatok dat
	
	infoheader.biSize = sizeof(BITMAPINFOHEADER);	// Header size in bytes			| velkost hlavicky BITMAPINFOHEADER
	infoheader.biWidth = scr_size_x;	// Width of image			| sirka obrazka - sizeX
	infoheader.biHeight = scr_size_y;	// Height of image			| vyska obrazka - sizeY
	infoheader.biPlanes = 1;		// Number of colour planes	| pocet farebnych rovin musi bit 1
	infoheader.biBitCount = 24;		// Bits per pixel			| bitov na pixel moze bit 1,4,8,24
	infoheader.biCompression = 0;	// Compression type			| typ compresie , 0 - bez kompresie
	infoheader.biSizeImage = line_size*infoheader.biHeight ;	// Image size in bytes		| velkost obrazka v byte
	infoheader.biXPelsPerMeter = 0;	// Pixels per meter X		| pixelov na meter v smere x
	infoheader.biYPelsPerMeter = 0;	// Pixels per meter Y		| pixelov na meter v smere y
	infoheader.biClrUsed = 0;		// Number of colours		| pocet  farieb v palete, ak 0 vsetky su pouzivane
	infoheader.biClrImportant = 0;	// Important colours		| dolezite farby v palete, ak 0 vsetky su dolezite
	
	sub = fopen(file,"wb");
	fwrite( &fileheader, sizeof(BITMAPFILEHEADER), 1, sub);
	fwrite( &infoheader, sizeof(BITMAPINFOHEADER), 1, sub);
	fwrite( buf, line_size*scr_size_y, 1, sub);

	delete[] buf;
	fclose(sub);
}

int Scene::LoadVertexShader(char *filename, DWORD *pDeclaration, DWORD* phVertexShader, char* verprog)
{
	int er=0;
	// Create the vertex shader.
	LPD3DXBUFFER pCode;                             // assembled shader code
	LPD3DXBUFFER pError;
	if(filename==NULL)
		D3DXAssembleShader( verprog, strlen(verprog), 0, NULL, &pCode, &pError );  // assemble shader code
	else
	{
		if( D3DXAssembleShaderFromFile( filename, 0, NULL, &pCode, &pError) != D3D_OK)er=1;  // assemble shader code
	}

	if(pError!=NULL)
	{
		char* error_text = new char[pError->GetBufferSize()+1];
		memcpy(error_text,pError->GetBufferPointer(),pError->GetBufferSize());
		error_text[pError->GetBufferSize()]=NULL;

		pError->Release();
		MessageBox(hWnd, error_text, "Chyba pri nacitavani vertex shader", MB_OK);
		delete [] error_text;
		phVertexShader = NULL;
		return 0;
	}
	else if(er==1)
	{
		MessageBox(hWnd, filename, "Nenajdeny subor pre vertex shader", MB_OK);
		return 0;
	}

	if(	pd->CreateVertexShader( pDeclaration, (DWORD*)pCode->GetBufferPointer(), phVertexShader, software_vertexprocessing )
		== D3D_OK )
	{
		pCode->Release();
		return 1;
	}
	pCode->Release();
	MessageBox(hWnd, filename, "Chyba pri nacitavani vertex shader", MB_OK);
	return 0;
}

int Scene::LoadPixelShader(char *filename, DWORD *phPixelShader, char *pixelprog)
{
	int er=0;
	// Create the pixel shader.
	LPD3DXBUFFER pCode;                             // assembled shader code
	LPD3DXBUFFER pError;
	if(filename==NULL)
		D3DXAssembleShader( pixelprog, strlen(pixelprog), 0, NULL, &pCode, &pError );  // assemble shader code
	else
	{
		if( D3DXAssembleShaderFromFile( filename, 0, NULL, &pCode, &pError) != D3D_OK)er=1;  // assemble shader code
	}

	if(pError!=NULL)
	{
		char* error_text = new char[pError->GetBufferSize()+1];
		memcpy(error_text,pError->GetBufferPointer(),pError->GetBufferSize());
		error_text[pError->GetBufferSize()]=NULL;

		pError->Release();
		MessageBox(hWnd, error_text, "Chyba pri nacitavani pixel shader", MB_OK);
		delete [] error_text;
		phPixelShader = NULL;
		return 0;
	}
	else if(er==1)
	{
		MessageBox(hWnd, filename, "Nenajdeny subor pre pixel shader", MB_OK);
		return 0;
	}

	if(	pd->CreatePixelShader( (DWORD*)pCode->GetBufferPointer(), phPixelShader )
		== D3D_OK )
	{
		pCode->Release();
		return 1;
	}
	pCode->Release();
	MessageBox(hWnd, filename, "Chyba pri nacitavani pixel shader", MB_OK);
	return 0;
}


int Scene::CreateVertexBufferForHelpRectange(float left, float top, float right, float bottom, float alpha)
{
	int size_of_custom_vertex = 3*sizeof(float)+sizeof(DWORD);
	if( FAILED( pd->CreateVertexBuffer( 4*size_of_custom_vertex,0, 
								D3DFVF_XYZ|D3DFVF_DIFFUSE,D3DPOOL_DEFAULT, &pvb_help_rectange ) ) )return 0;
	void* p1;
	if( FAILED( pvb_help_rectange->Lock( 0, 4*size_of_custom_vertex, (BYTE**)&p1, 0 ) ) )return 0;
	((float*)p1)[0*4+0] = left;
	((float*)p1)[0*4+1] = bottom;
	((float*)p1)[0*4+2] = 0;
	((DWORD*)p1)[0*4+3] = D3DCOLOR_COLORVALUE(0.0f,0.0f,0.0f,alpha);
	((float*)p1)[1*4+0] = right;
	((float*)p1)[1*4+1] = bottom;
	((float*)p1)[1*4+2] = 0;
	((DWORD*)p1)[1*4+3] = D3DCOLOR_COLORVALUE(0.0f,0.0f,0.0f,alpha);
	((float*)p1)[2*4+0] = left;
	((float*)p1)[2*4+1] = top;
	((float*)p1)[2*4+2] = 0;
	((DWORD*)p1)[2*4+3] = D3DCOLOR_COLORVALUE(0.0f,0.0f,0.0f,alpha);
	((float*)p1)[3*4+0] = right;
	((float*)p1)[3*4+1] = top;
	((float*)p1)[3*4+2] = 0;
	((DWORD*)p1)[3*4+3] = D3DCOLOR_COLORVALUE(0.0f,0.0f,0.0f,alpha);
	pvb_help_rectange->Unlock();
	return 1;
} 

int Scene::ReadInit(char *filename)
{
	FILE* sub=NULL;
	char temp[100];
	char varname[100],varvalue[100];
	int ret=0;

	sub = fopen( filename, "rb");
	if(sub == NULL)return 0;

	renderableCubeTexture=0;
	while(GetVariable( temp, sub, varname, varvalue, 100))
	{
		float fl=(float)atof(varvalue);
		int in=atoi(varvalue);
	//	strlwr(varname);				// Convert a string to lowercase
		if(!strcmp("renderableCubeTexture",varname))renderableCubeTexture=in;
	}
	fclose(sub);
	if(renderableCubeTexture==0)renderableCubeTexture=128;
	return 1;
}

int Scene::GetVariable(char *temp, FILE *sub, char *varname, char *varvalue, int size_strings)
{
	if(fgets(temp, size_strings, sub) == NULL)
	{
		temp[0] = NULL;
		return 0;
	}
	varname[0]=NULL;
	varvalue[0]=NULL;
	char rovnasa=0;
	for(int i=0,j=0,k=0; temp[i]!=NULL&&temp[i]!='\n'&&temp[i]!='/'; i++)		// prejdeme vsetky znaky
	{
		if(temp[i]==' ' || temp[i]=='\t')continue;
		if(temp[i]=='='){ rovnasa=1;continue;}
		if(rovnasa)
		{
			varvalue[k]=temp[i]; k++;
		}
		else
		{
			varname[j]=temp[i]; j++;
		}
	}
	varname[j]=NULL;
	varvalue[k]=NULL;
	return 1;
}

